Summary: Computing Resource Execution And Management service
Name: glite-ce-cream
Version: 1.16.4
Release: 1%{?dist}%{!?dist:.el5}
License: Apache Software License
Vendor: EMI
URL: http://glite.cern.ch/
Group: Applications/Internet
BuildArch: noarch
BuildRequires: maven
Requires: glite-ce-cream-utils, glite-ce-cream-core, glite-ce-blahp, mysql-connector-java
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
AutoReqProv: yes
Source: %{name}.tar.gz

%global _tomcat %{?el6:tomcat6}%{!?el6:tomcat5}
%global _creamlibdir /var/lib/%{_tomcat}/webapps/ce-cream/WEB-INF/lib
%global _eslibdir /var/lib/%{_tomcat}/webapps/ce-cream-es/WEB-INF/lib

%description
The Computing Resource Execution And Management service is a web application
taking care of the any job related operation

%prep
 

%setup -c -q

%build
mvn -Drpm.repackaging=false -DskipTests compile

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}
mvn -Drpm.repackaging=false -DskipTests install
mkdir -p %{buildroot}/usr/share/java
cp %{_builddir}/%{name}-%{version}/target/cream-1.16.4.jar %{buildroot}/usr/share/java/glite-ce-cream-core.jar
cp %{_builddir}/%{name}-%{version}/target/plugins/cream-activityExecutor.jar %{buildroot}/usr/share/java/glite-ce-cream-activityExecutor.jar
cp %{_builddir}/%{name}-%{version}/target/plugins/cream-blahExecutor.jar %{buildroot}/usr/share/java/glite-ce-cream-blahExecutor.jar
cp %{_builddir}/%{name}-%{version}/target/plugins/cream-delegationExecutor.jar %{buildroot}/usr/share/java/glite-ce-cream-delegationExecutor.jar
cp %{_builddir}/%{name}-%{version}/target/cream-client.jar %{buildroot}/usr/share/java/glite-ce-cream-clients.jar
mkdir -p %{buildroot}/usr/share/glite-ce-cream/services
cp %{_builddir}/%{name}-%{version}/target/cream-es-interface.jar %{buildroot}/usr/share/glite-ce-cream/services/glite-ce-cream-es.aar
cp %{_builddir}/%{name}-%{version}/target/cream-legacy-interface.jar %{buildroot}/usr/share/glite-ce-cream/services/glite-ce-cream.aar
mkdir -p %{buildroot}/usr/share/glite-ce-cream/modules
cp %{_builddir}/%{name}-%{version}/target/cream-authorization.jar %{buildroot}/usr/share/glite-ce-cream/modules/glite-ce-cream-authorization.mar
mkdir -p %{buildroot}/etc/glite-ce-cream
cp %{_builddir}/%{name}-%{version}/config/cream/db/*.sql %{buildroot}/etc/glite-ce-cream
cp %{_builddir}/%{name}-%{version}/config/cream/log4j.properties %{buildroot}/etc/glite-ce-cream
cp %{_builddir}/%{name}-%{version}/target/cream-defs/services.properties %{buildroot}/etc/glite-ce-cream/service.properties
cp %{_builddir}/%{name}-%{version}/config/cream/*.template %{buildroot}/etc/glite-ce-cream
cp %{_builddir}/%{name}-%{version}/config/cream/*.tpl %{buildroot}/etc/glite-ce-cream
cp %{_builddir}/%{name}-%{version}/config/cream/web.xml %{buildroot}/etc/glite-ce-cream
sed -e 's|__CHANGE_SERVICE__|/etc/glite-ce-cream/cream-config.xml|g' \
    -e 's|__CHANGE_LOG4J__|/etc/glite-ce-cream/log4j.properties|g' \
    %{_builddir}/%{name}-%{version}/config/cream/axis2.xml > %{buildroot}/etc/glite-ce-cream/axis2.xml

mkdir -p %{buildroot}/etc/glite-ce-cream-es
cp %{_builddir}/%{name}-%{version}/config/cream-es/db/*.sql %{buildroot}/etc/glite-ce-cream-es
cp %{_builddir}/%{name}-%{version}/config/cream-es/log4j.properties %{buildroot}/etc/glite-ce-cream-es
cp %{_builddir}/%{name}-%{version}/config/cream-es/services.properties %{buildroot}/etc/glite-ce-cream-es/service.properties
cp %{_builddir}/%{name}-%{version}/config/cream-es/*.template %{buildroot}/etc/glite-ce-cream-es
cp %{_builddir}/%{name}-%{version}/config/cream-es/*.tpl %{buildroot}/etc/glite-ce-cream-es
mkdir -p %{buildroot}/etc/glite-ce-cream-es/storedprocedures
cp %{_builddir}/%{name}-%{version}/config/cream-es/db/storedprocedures/*.sql %{buildroot}/etc/glite-ce-cream-es/storedprocedures
cp %{_builddir}/%{name}-%{version}/config/cream-es/web.xml %{buildroot}/etc/glite-ce-cream-es
sed -e 's|__CHANGE_SERVICE__|/etc/glite-ce-cream-es/cream-config.xml|g' \
    -e 's|__CHANGE_LOG4J__|/etc/glite-ce-cream-es/log4j.properties|g' \
    %{_builddir}/%{name}-%{version}/config/cream-es/axis2.xml > %{buildroot}/etc/glite-ce-cream-es/axis2.xml

%clean
rm -rf %{buildroot}

%pre
for((idx=0; idx<5; idx++)) ; do
  /sbin/service %{_tomcat} stop
  if [ $? == 0 ] ; then idx=5; else sleep 5; fi
done

%post
set -e

[ -d /var/lib/%{_tomcat}/webapps/ce-cream ] || cp -R /usr/share/axis2/webapp /var/lib/%{_tomcat}/webapps/ce-cream

if [ -e /usr/share/java/bcprov-1.46.jar ] ; then
    ln -sf /usr/share/java/bcprov-1.46.jar %{_creamlibdir}/bcprov.jar
else
    ln -sf /usr/share/java/bcprov.jar %{_creamlibdir}
fi

if [ -e /usr/share/java/bcmail-1.46.jar ] ; then
    ln -sf /usr/share/java/bcmail-1.46.jar %{_creamlibdir}/bcmail.jar
else
    ln -sf /usr/share/java/bcmail.jar %{_creamlibdir}
fi

#removing broken links from previous installation
find -L %{_creamlibdir} -type l -exec rm -f '{}' \;

[ -h %{_creamlibdir}/cedar.jar ] || ln -s /usr/share/java/jclassads/cedar.jar %{_creamlibdir}
[ -h %{_creamlibdir}/classad.jar ] || ln -s /usr/share/java/jclassads/classad.jar %{_creamlibdir}
[ -h %{_creamlibdir}/argus-pep-api-java.jar ] || ln -s /usr/share/java/argus-pep-api-java.jar %{_creamlibdir}
[ -h %{_creamlibdir}/argus-pep-common.jar ] || ln -s /usr/share/java/argus-pep-common.jar %{_creamlibdir}
[ -h %{_creamlibdir}/canl.jar ] || ln -s /usr/share/java/canl.jar %{_creamlibdir}
[ -h %{_creamlibdir}/voms-api-java3.jar ] || ln -s /usr/share/java/voms-api-java3.jar %{_creamlibdir}
[ -h %{_creamlibdir}/glite-jobid-api-java.jar ] || ln -s /usr/share/java/glite-jobid-api-java.jar %{_creamlibdir}
if [ -e /usr/lib/java/glite-lb-client-java.jar ] ; then
    [ -h %{_creamlibdir}/glite-lb-client-java.jar ] || ln -s /usr/lib/java/glite-lb-client-java.jar %{_creamlibdir}
else
    [ -h %{_creamlibdir}/glite-lb-client-java.jar ] || ln -s /usr/share/java/glite-lb-client-java.jar %{_creamlibdir}
fi
[ -h %{_creamlibdir}/glite-ce-common-java.jar ] || ln -s /usr/share/java/glite-ce-common-java.jar %{_creamlibdir}
[ -h %{_creamlibdir}/glite-ce-cream-api-java.jar ] || ln -s /usr/share/java/glite-ce-cream-api-java.jar %{_creamlibdir}
[ -h %{_creamlibdir}/glite-ce-cream-blahExecutor.jar ] || ln -s /usr/share/java/glite-ce-cream-blahExecutor.jar %{_creamlibdir}
[ -h %{_creamlibdir}/glite-ce-cream-core.jar ] || ln -s /usr/share/java/glite-ce-cream-core.jar %{_creamlibdir}
[ -h %{_creamlibdir}/glite-ce-cream-delegationExecutor.jar ] || ln -s /usr/share/java/glite-ce-cream-delegationExecutor.jar %{_creamlibdir}
[ -h %{_creamlibdir}/glite-ce-cream-skeleton.jar ] || ln -s /usr/share/java/glite-ce-cream-skeleton.jar %{_creamlibdir}
[ -h %{_creamlibdir}/glite-ce-delegation-skeleton.jar ] || ln -s /usr/share/java/glite-ce-delegation-skeleton.jar %{_creamlibdir}
[ -h %{_creamlibdir}/glite-jdl-api-java.jar ] || ln -s /usr/share/java/glite-jdl-api-java.jar %{_creamlibdir}

#removing EMI-2 symlinks
[ -h %{_creamlibdir}/delegation-java.jar ] && rm -f %{_creamlibdir}/delegation-java.jar
[ -h %{_creamlibdir}/trustmanager.jar ] && rm -f %{_creamlibdir}/trustmanager.jar
[ -h %{_creamlibdir}/voms-api-java.jar ] && rm -f %{_creamlibdir}/voms-api-java.jar

#removing EMI-3 compat symlinks
[ -h %{_creamlibdir}/argus-pep-api-java-compat.jar ] && rm -f %{_creamlibdir}/argus-pep-api-java-compat.jar
[ -h %{_creamlibdir}/argus-pep-common-compat.jar ] && rm -f %{_creamlibdir}/argus-pep-common-compat.jar
[ -h %{_creamlibdir}/delegation-java-compat.jar ] && rm -f %{_creamlibdir}/delegation-java-compat.jar

%if 0%{?el6}
# set allowLinking option for tomcat6
if [ ! -d /var/lib/%{_tomcat}/webapps/ce-cream/META-INF ] ; then
  mkdir /var/lib/%{_tomcat}/webapps/ce-cream/META-INF
  echo '<Context override="true" allowLinking="true"></Context>' > /var/lib/%{_tomcat}/webapps/ce-cream/META-INF/context.xml
fi
%endif

ln -sf /usr/share/glite-ce-cream/modules/glite-ce-cream-authorization.mar /var/lib/%{_tomcat}/webapps/ce-cream/WEB-INF/modules
find /var/lib/%{_tomcat}/webapps/ce-cream/WEB-INF/modules -name *.mar -exec basename \{\} \; > /var/lib/%{_tomcat}/webapps/ce-cream/WEB-INF/modules/modules.list
  
ln -sf /usr/share/glite-ce-cream/services/glite-ce-cream.aar /var/lib/%{_tomcat}/webapps/ce-cream/WEB-INF/services
find /var/lib/%{_tomcat}/webapps/ce-cream/WEB-INF/services -name *.aar -exec basename \{\} \; >  /var/lib/%{_tomcat}/webapps/ce-cream/WEB-INF/services/services.list

cp /etc/glite-ce-dbtool/creamdb_min_access.conf.template /etc/glite-ce-cream/creamdb_min_access.conf

# cannot use symlinks for the following files, copy is needed:
cp -f /etc/glite-ce-cream/web.xml /var/lib/%{_tomcat}/webapps/ce-cream/WEB-INF/
cp -f /etc/glite-ce-cream/axis2.xml /var/lib/%{_tomcat}/webapps/ce-cream/WEB-INF/conf/
chmod 600 /var/lib/%{_tomcat}/webapps/ce-cream/WEB-INF/conf/axis2.xml
chown tomcat.tomcat /var/lib/%{_tomcat}/webapps/ce-cream/WEB-INF/conf/axis2.xml

if [ $1 -eq 1 ] ; then
# Creation of the back-end and log dir
  if [ ! "x`grep tomcat /etc/passwd`" == "x" ] ; then
    mkdir -p /var/cream_sandbox
    chown tomcat:tomcat /var/cream_sandbox
    chmod 775 /var/cream_sandbox

    mkdir -p /var/log/cream
    chown tomcat:tomcat /var/log/cream
    chmod 755 /var/log/cream

  fi
    
  /sbin/service %{_tomcat} start
  
fi

%preun
if [ $1 -eq 0 ] ; then

  for((idx=0; idx<5; idx++)) ; do
    /sbin/service %{_tomcat} stop
    if [ $? == 0 ] ; then idx=5; else sleep 5; fi
  done

  if [ -d /var/lib/%{_tomcat}/webapps/ce-cream ] ; then 
    rm -rf /var/lib/%{_tomcat}/webapps/ce-cream
  fi
    
  if [ -e /etc/%{_tomcat}/Catalina/localhost/ce-cream.xml ] ; then
    rm -f /etc/%{_tomcat}/Catalina/localhost/ce-cream.xml
  fi
    
  rm -f /etc/glite-ce-cream/creamdb_min_access.conf

fi

%postun
/sbin/service %{_tomcat} start


%files
%defattr(-,root,root)
%dir /etc/glite-ce-cream/
%config(noreplace) /etc/glite-ce-cream/*.sql
%config(noreplace) /etc/glite-ce-cream/*.template
%config(noreplace) /etc/glite-ce-cream/*.tpl
%config(noreplace) /etc/glite-ce-cream/*.properties
%config(noreplace) /etc/glite-ce-cream/*.xml
/usr/share/glite-ce-cream/services/glite-ce-cream.aar







%package core
Summary: Common classes for CREAM services
Group: Applications/Internet
Requires: glite-ce-cream-api-java

%description core
This package contains the core libraries used by CREAM services

%files core
%defattr(-,root,root)
/usr/share/java/glite-ce-cream*.jar
%dir /usr/share/glite-ce-cream/modules
/usr/share/glite-ce-cream/modules/*.mar
%dir /usr/share/glite-ce-cream/services








%package es
Summary: The gLite implementation of EMI Execution Service
Group: Applications/Internet
Requires: glite-ce-cream-utils, glite-ce-cream-core, glite-ce-blahp, mysql-connector-java

%description es
This package provides the gLite implementation of Execution Service interface.
The interface is built on top of the core of the Computing Resource Execution 
And Management service.

%files es
%defattr(-,root,root)
%dir /etc/glite-ce-cream-es/
%config(noreplace) /etc/glite-ce-cream-es/*.sql
%config(noreplace) /etc/glite-ce-cream-es/*.template
%config(noreplace) /etc/glite-ce-cream-es/*.tpl
%config(noreplace) /etc/glite-ce-cream-es/*.properties
%config(noreplace) /etc/glite-ce-cream-es/*.xml
%config(noreplace) /etc/glite-ce-cream-es/storedprocedures/*.sql
/usr/share/glite-ce-cream/services/glite-ce-cream-es.aar

%pre es
for((idx=0; idx<5; idx++)) ; do
  /sbin/service %{_tomcat} stop
  if [ $? == 0 ] ; then idx=5; else sleep 5; fi
done

%post es
set -e

[ -d /var/lib/%{_tomcat}/webapps/ce-cream-es ] || cp -R /usr/share/axis2/webapp /var/lib/%{_tomcat}/webapps/ce-cream-es

if [ -e /usr/share/java/bcprov-1.46.jar ] ; then
    ln -sf /usr/share/java/bcprov-1.46.jar %{_eslibdir}/bcprov.jar
else
    ln -sf /usr/share/java/bcprov.jar %{_eslibdir}
fi

if [ -e /usr/share/java/bcmail-1.46.jar ] ; then
    ln -sf /usr/share/java/bcmail-1.46.jar %{_eslibdir}/bcmail.jar
else
    ln -sf /usr/share/java/bcmail.jar %{_eslibdir}
fi

#removing broken links from previous installation
find -L %{_eslibdir} -type l -exec rm -f '{}' \;

[ -h %{_eslibdir}/cedar.jar ] || ln -s /usr/share/java/jclassads/cedar.jar %{_eslibdir}
[ -h %{_eslibdir}/classad.jar ] || ln -s /usr/share/java/jclassads/classad.jar %{_eslibdir}
[ -h %{_eslibdir}/argus-pep-api-java.jar ] || ln -s /usr/share/java/argus-pep-api-java.jar %{_eslibdir}
[ -h %{_eslibdir}/argus-pep-common.jar ] || ln -s /usr/share/java/argus-pep-common.jar %{_eslibdir}
[ -h %{_eslibdir}/canl.jar ] || ln -s /usr/share/java/canl.jar %{_eslibdir}
[ -h %{_eslibdir}/voms-api-java3.jar ] || ln -s /usr/share/java/voms-api-java3.jar %{_eslibdir}
[ -h %{_eslibdir}/glite-jobid-api-java.jar ] || ln -s /usr/share/java/glite-jobid-api-java.jar %{_eslibdir}
if [ -e /usr/lib/java/glite-lb-client-java.jar ] ; then
    [ -h %{_eslibdir}/glite-lb-client-java.jar ] || ln -s /usr/lib/java/glite-lb-client-java.jar %{_eslibdir}
else
    [ -h %{_eslibdir}/glite-lb-client-java.jar ] || ln -s /usr/share/java/glite-lb-client-java.jar %{_eslibdir}
fi
[ -h %{_eslibdir}/glite-ce-common-java.jar ] || ln -s /usr/share/java/glite-ce-common-java.jar %{_eslibdir}
[ -h %{_eslibdir}/glite-ce-cream-api-java.jar ] || ln -s /usr/share/java/glite-ce-cream-api-java.jar %{_eslibdir}
[ -h %{_eslibdir}/glite-ce-cream-blahExecutor.jar ] || ln -s /usr/share/java/glite-ce-cream-blahExecutor.jar %{_eslibdir}
[ -h %{_eslibdir}/glite-ce-cream-core.jar ] || ln -s /usr/share/java/glite-ce-cream-core.jar %{_eslibdir}
[ -h %{_eslibdir}/glite-ce-cream-delegationExecutor.jar ] || ln -s /usr/share/java/glite-ce-cream-delegationExecutor.jar %{_eslibdir}
[ -h %{_eslibdir}/glite-ce-cream-es-skeleton.jar ] || ln -s /usr/share/java/glite-ce-cream-es-skeleton.jar %{_eslibdir}
[ -h %{_eslibdir}/glite-ce-delegation-skeleton.jar ] || ln -s /usr/share/java/glite-ce-delegation-skeleton.jar %{_eslibdir}
[ -h %{_eslibdir}/glite-jdl-api-java.jar ] || ln -s /usr/share/java/glite-jdl-api-java.jar %{_eslibdir}

#removing EMI-2 symlinks
[ -h %{_eslibdir}/delegation-java.jar ] && rm -f %{_eslibdir}/delegation-java.jar
[ -h %{_eslibdir}/trustmanager.jar ] && rm -f %{_eslibdir}/trustmanager.jar
[ -h %{_eslibdir}/voms-api-java.jar ] && rm -f %{_eslibdir}/voms-api-java.jar

#removing EMI-3 compat symlinks
[ -h %{_eslibdir}/argus-pep-api-java-compat.jar ] && rm -f %{_eslibdir}/argus-pep-api-java-compat.jar
[ -h %{_eslibdir}/argus-pep-common-compat.jar ] && rm -f %{_eslibdir}/argus-pep-common-compat.jar
[ -h %{_eslibdir}/delegation-java-compat.jar ] && rm -f %{_eslibdir}/delegation-java-compat.jar

%if 0%{?el6}
# set allowLinking option for tomcat6
if [ ! -d /var/lib/%{_tomcat}/webapps/ce-cream-es/META-INF ] ; then
  mkdir /var/lib/%{_tomcat}/webapps/ce-cream-es/META-INF
  echo '<Context override="true" allowLinking="true"></Context>' > /var/lib/%{_tomcat}/webapps/ce-cream-es/META-INF/context.xml
fi
%endif

ln -sf /usr/share/glite-ce-cream/modules/glite-ce-cream-authorization.mar /var/lib/%{_tomcat}/webapps/ce-cream-es/WEB-INF/modules
find /var/lib/%{_tomcat}/webapps/ce-cream-es/WEB-INF/modules -name *.mar -exec basename \{\} \; > /var/lib/%{_tomcat}/webapps/ce-cream-es/WEB-INF/modules/modules.list
  
ln -sf /usr/share/glite-ce-cream/services/glite-ce-cream-es.aar /var/lib/%{_tomcat}/webapps/ce-cream-es/WEB-INF/services
find /var/lib/%{_tomcat}/webapps/ce-cream-es/WEB-INF/services -name *.aar -exec basename \{\} \; > /var/lib/%{_tomcat}/webapps/ce-cream-es/WEB-INF/services/services.list

cp /etc/glite-ce-dbtool/creamdb_min_access.conf.template /etc/glite-ce-cream-es/creamdb_min_access.conf
  
# cannot use symlinks for the following files, copy is needed:
cp -f /etc/glite-ce-cream-es/web.xml /var/lib/%{_tomcat}/webapps/ce-cream-es/WEB-INF/
cp -f /etc/glite-ce-cream-es/axis2.xml /var/lib/%{_tomcat}/webapps/ce-cream-es/WEB-INF/conf
chmod 600 /var/lib/%{_tomcat}/webapps/ce-cream-es/WEB-INF/conf/axis2.xml
chown tomcat.tomcat /var/lib/%{_tomcat}/webapps/ce-cream-es/WEB-INF/conf/axis2.xml

if [ $1 -eq 1 ] ; then
# Creation of the back-end and log dir
  if [ ! "x`grep tomcat /etc/passwd`" == "x" ] ; then
    mkdir -p /var/cream_es_sandbox 
    chown tomcat:tomcat /var/cream_es_sandbox 
    chmod 775 /var/cream_es_sandbox 
    
    mkdir -p /var/log/cream-es
    chown tomcat:tomcat /var/log/cream-es
    chmod 755 /var/log/cream-es

  fi
    
  /sbin/service %{_tomcat} start
  
fi

%preun es
if [ $1 -eq 0 ] ; then

  for((idx=0; idx<5; idx++)) ; do
    /sbin/service %{_tomcat} stop
    if [ $? == 0 ] ; then idx=5; else sleep 5; fi
  done

  if [ -d /var/lib/%{_tomcat}/webapps/ce-cream-es ] ; then 
    rm -rf /var/lib/%{_tomcat}/webapps/ce-cream-es
  fi
    
  if [ -e /etc/%{_tomcat}/Catalina/localhost/ce-cream-es.xml ] ; then
    rm -f /etc/%{_tomcat}/Catalina/localhost/ce-cream-es.xml
  fi
    
  rm -f /etc/glite-ce-cream-es/creamdb_min_access.conf
  
fi

%postun es
/sbin/service %{_tomcat} start


%changelog
* Fri Jul 04 2014 CREAM group <cream-support@lists.infn.it> - 1.16.4-1
- Replaced C-based voms-client call with java-based one

* Fri May 30 2014 CREAM group <cream-support@lists.infn.it> - 1.16.3-1
- Fix for bug https://issues.infn.it/jira/browse/CREAM-134
- Fix for bug https://issues.infn.it/jira/browse/CREAM-145

* Mon Sep 30 2013 CREAM group <cream-support@lists.infn.it> - 1.16.2-1
- Fix for bug https://issues.infn.it/jira/browse/CREAM-111
- Fix for bug https://issues.infn.it/jira/browse/CREAM-113

* Fri Jun 28 2013 CREAM group <cream-support@lists.infn.it> - 1.16.1-2
- New major release


